//----------------------------------------------------------------------------
// JX^tB^Tvi2D NLM NRj
// Copyright (c) 2008,2009 N099
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// HLSLуGtFNĝɂĂDirectX SDKMSDNQƂĂ
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// NLM̎ɂẮANVIDIÄȉ̕уTvQƂ܂
// [URI] http://developer.download.nvidia.com/compute/cuda/1_1/Website/projects/imageDenoising/doc/imageDenoising.pdf
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// tB^̒`
//
//   tB^Ag񂨂уo[Wݒ肵܂B
//   ̐ݒ肪̂܂AviUtl{̂ŎQƁE\܂B
//----------------------------------------------------------------------------
int4 FilterVersion
 <
	//name: tB^̖OiݒȂǂł̕\jł
	string name    = "GPUJX^(NLM2D)";
	
	//ex_info: vOCtB^ŕ\镶ł
	//ۂ͂̌ɁAo[Wio[ǉĕ\܂
	string ex_info = "gpuc_nlmf2d by N099";
	
	//img_format: 摜tH[}bgw肵܂
	string img_format = "F32";
	
	//min_ps_ver: tB^̓ɕKvps̃o[Ww肵܂
	int2 min_ps_ver = { 3, 0 };
	
 > = { 0, 5, 0, 0 };
//4vf̃o[WłB擪2ex_infǒɕ\܂B

//----------------------------------------------------------------------------
// ݒp[^
//
//   AviUtlł̐ݒ_CAÕgbNo[ƃ`FbN{bNXݒ
//   擾܂B
//   Track#,Check#i#0n܂Aԁj͂ꂼgbNo[
//   `FbN{bNXɑΉ܂B
//   ݒ薼AlїL͈͂Ȃǂw肵ĂB
//
//   ȂA"usage"p[^ɂăp[^l̉߂ύXł܂B
//   ӁF擾ľ^(float,int,bool)K킹ĂB
//----------------------------------------------------------------------------

//s߂̒T͈
int Track0
<
	string name = "͈";
	int min = 1;
	int max = 5;
	int def = 2;
	string usage = "odd";
>;

//ubNm̋ɑ΂d
float Track1
<
	string name = "";
	int min = 0;
	int max = 256;
	int def = 0;
	string usage = "normalize";
>;

//ubNł̉fl̘̍aɑ΂d
float Track2
<
	string name = "F";
	int min = 0;
	int max = 256;
	int def = 128;
	string usage = "normalize";
>;

//ʂ̃ubNTCYIł悤ɂ
int Track3
<
	string name = "";
	int min = 0;
	int max = 3;
	int def = 1;
	string usage = "odd";
>;

//ł̒S̋ɑ΂d
float Track4
<
	string name = "";
	int min = 0;
	int max = 256;
	int def = 0;
	string usage = "normalize";
>;

//FԂ̎w
bool Check0
<
	string name = "BT.709";
	bool def = false;
	string usage = "technique";
>;

//----------------------------------------------------------------------------
// ÕpXŏo͂摜i[eNX`
//
//   peNjbÑpXō\ĂꍇAÕpXł
//   o͌ʂ"TxTmp"Ɋi[AQƂ邱Ƃł܂B
//   Aŏ̃pX̎_ł́Ã݂t[f[^Ă܂B
//----------------------------------------------------------------------------
texture TxTmp;

//----------------------------------------------------------------------------
// eNX`TviOȂǂ͔Cӂ̂̂𗘗pĂ܂܂j
//----------------------------------------------------------------------------
sampler2D samTmp =
sampler_state
{
    Texture = <TxTmp>;
    AddressU = Mirror;
    AddressV = Mirror;
    MinFilter = Point;
    MagFilter = Point;
};

//----------------------------------------------------------------------------
// sNZWeNX`Wɕϊ邽߂̔z
//
//   PixelKernel#,TexelKernel#i#0n܂Aԁj̃yAɂA
//   sNZPʂeNX`Wł̃ItZbgIɌvZ܂B
//   float2̔zŁAvf͕KɂĂB
//----------------------------------------------------------------------------
//sNZPʂł̃ItZbg
float2 PixelKernel0[1] = { 1.0f, 1.0f };

//eNX`WɕϊItZbg
float2 TexelKernel0[1];

//----------------------------------------------------------------------------
// RGB <-> YC BT.601
//----------------------------------------------------------------------------
const float3x3 matYC2RGB601 = 
{ 1.0f,  0.000000f,  1.402000f,
  1.0f, -0.344136f, -0.714136f,
  1.0f,  1.772000f,  0.000000f
};
  
const float3x3 matRGB2YC601 = 
{  0.299000f,  0.587000f,  0.114000f,
  -0.168736f, -0.331264f,  0.500000f,
   0.500000f, -0.418688f, -0.081312f
};

//----------------------------------------------------------------------------
// RGB <-> YC BT.709
//----------------------------------------------------------------------------
const float3x3 matYC2RGB709 = 
{ 1.0f,  0.000000f,  1.574800f,
  1.0f, -0.187324f, -0.468124f,
  1.0f,  1.855600f,  0.000000f
};
  
const float3x3 matRGB2YC709 = 
{  0.212600f,  0.715200f,  0.072200f,
  -0.114572f, -0.385428f,  0.500000f,
   0.500000f, -0.454153f, -0.045847f
};

//-----------------------------------------------------------------------------
// Pixel Shader: ToLinearRGB
// Desc: RGBɕϊ(F32/F16 only)
//-----------------------------------------------------------------------------
float4 ToLinearRGB(float2 Tex : TEXCOORD0, uniform bool bt709) : COLOR0
{
	float3 rgb,ycc = tex2D(samTmp, Tex).rgb;

	if(bt709){
		rgb = mul(matYC2RGB709, ycc);
	}else{
		rgb = mul(matYC2RGB601, ycc);
	}

	float3 lo,hi,mask;

	mask = step(0.081f, rgb);
	hi = mask * rgb;
	lo = rgb - hi;

	lo /= 4.50f;
	hi = pow((hi + 0.099f)/1.099f, 1.0f/0.45f);

	return float4(lo + mask * hi, 0.0f);
}

//-----------------------------------------------------------------------------
// YCbCrɖ߂
//-----------------------------------------------------------------------------
float4 ToYCC(float3 rgb, uniform bool bt709)
{
	float3 lo,hi,mask;

	mask = step(0.018f, rgb);
	hi = mask * rgb;
	lo = rgb - hi;

	lo *= 4.50f;
	hi = pow(hi, 0.45f) * 1.099f - 0.099f;
	rgb = lo + mask * hi;

	float3 ycc;
	if(bt709){
		ycc = mul(matRGB2YC709, rgb);
	}else{
		ycc = mul(matRGB2YC601, rgb);
	}

	return float4(ycc, 0.0f);
}

//-----------------------------------------------------------------------------
// ̐F߂
//-----------------------------------------------------------------------------
float WndColorDistance(float2 tex, float2 offs, float wdt)
{
	float wwnd = 0.0f;

	[loop]for(int i = 0; i < Track3; i++){
		[loop]for(int j = 0; j < Track3; j++){
			float2 wpos = float2(j, i) - (Track3 / 2);
			float4 txref = float4(tex + wpos * TexelKernel0[0], 0.0f, 0.0f);
			float4 txtgt = float4(tex + (wpos + offs) * TexelKernel0[0], 0.0f, 0.0f);
			float2 cd;

			cd = tex2Dlod(samTmp, txtgt).rgb - tex2Dlod(samTmp, txref).rgb;
			wwnd += exp(-dot(wpos, wpos) * wdt) * dot(cd, cd);
		}
	}

	return wwnd;
}

//-----------------------------------------------------------------------------
// Pixel Shader: NLM2D
// Desc: 2D NLM NR
//-----------------------------------------------------------------------------
float4 NLM2D(float2 Tex : TEXCOORD0, uniform bool bt709) : COLOR0
{
	float wsum = 0.0f;
	float3 rgb = { 0.0f, 0.0f, 0.0f };
	const float sdt = pow(8.0f * Track1 / Track0, 2.0f); //
	const float cdt = pow((exp(10.0f * Track2) - 1.0f) / Track3, 2.0f); //F
	const float wdt = pow(8.0f * Track4 / Track3, 2.0f); //̋

	// T͈͂͏c Track0 sNZ
	[loop]for(int i = 0; i < Track0; ++i){
		[loop]for(int j = 0; j < Track0; ++j){
			float2 offs = float2(j, i) - (Track0 / 2);
			float4 txsrc = float4(Tex + offs * TexelKernel0[0], 0.0f, 0.0f);

			// ŐFvZ
			float wwnd = WndColorDistance(Tex, offs, wdt);

			// TƐFd݂vZ
			wwnd = exp(-(wwnd * cdt + dot(offs, offs) * sdt));

			// dݕtFv
			rgb += wwnd * tex2Dlod(samTmp, txsrc).rgb;

			// K邽ߏd݂vĂ
			wsum += wwnd;
		}
	}

	// RGBł̑a𐳋K
	rgb /= wsum;

	// YCbCrɖ߂
	return ToYCC(rgb, bt709);
}

//----------------------------------------------------------------------------
// eNjbN
//
//   ProcessImage#i#0n܂AԁjƂOŃeNjbNLq܂B
//   Track#p[^ŁApeNjbNԍw肷邱Ƃł܂B
//----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Technique: ProcessImage0
// Desc: 2D NLM NR (BT.601)
//-----------------------------------------------------------------------------
technique ProcessImage0
{
	pass p0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 ToLinearRGB(false);
		ZEnable = false;
	}
	pass p1
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 NLM2D(false);
		ZEnable = false;
	}
}

//-----------------------------------------------------------------------------
// Technique: ProcessImage1
// Desc: 2D NLM NR (BT.709)
//-----------------------------------------------------------------------------
technique ProcessImage1
{
	pass p0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 ToLinearRGB(true);
		ZEnable = false;
	}
	pass p1
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 NLM2D(true);
		ZEnable = false;
	}
}

